/*****************************************************************************
 * example1.cpp
 ***************************************************************************** 
 *
 * Projekt:     Halcon/C++
 * Author:      W. Eckstein
 * Description: Example for Halcon/C++
 *
 * (c) 1996-98 by MVTec Software GmbH
 *                Orleansstr. 34, D-81667 Muenchen, Germany
 *****************************************************************************
 *   - read image     
 *   - open graphics window
 *   - threshold for eyes of the mandrill
 *   - Connection
 *   - Selection of area and anisometry
 *   - output of the filled and extended eyes
 *   - Program ends by mouse click
 *****************************************************************************
 *
 * $Revision: 1.2 $
 * $Date: 1998/02/24 10:44:06 $
 */

#include "HalconCpp.h"
#include <iostream.h>


main()
{
  HRegionArray  Eyes;                     // Result of the segmentation
  HByteImage    Mandrill("monkey");       // Read input image
  HWindow       w;                        // Open window with default size

  Mandrill.Display (w);                   // display the Mandrill

  HRegionArray regs = (Mandrill >= 128).Connection();  // find bright regions

  for (long i = 0; i < regs.Num(); i++)   // check each region
  {
    if ((regs[i].Area() > 500) &&         // for minimum size
        (regs[i].Area() < 50000) &&       // for maximum size
	(regs[i].Anisometry() < 1.7))     // and shape
    {
       Eyes.Append(regs[i]);              // Add found region to the list
    }
  }

  w.SetColor ("red");                     // prepare display of regions
  w.SetDraw  ("margin");

  (Eyes.FillUp() << 9).Display(w);        // expand filled eyes and display
  (void) w.Click();                       // wait for mouse click

  return(0);
}


