/*****************************************************************************
 * example10.cpp
 ***************************************************************************** 
 *
 * Projekt:     Halcon/C++
 * Author:      W. Eckstein
 * Description: Example for Halcon/C++
 *
 * (c) 1996-98 by MVTec Software GmbH
 *                Orleansstr. 34, D-81667 Muenchen, Germany
 *****************************************************************************
 *    
 *****************************************************************************
 *
 * $Revision: 1.2 $
 * $Date: 1998/02/24 10:44:06 $
 */


#include "HalconCpp.h"
#include <iostream.h>
 

main()
{
  HWindow w(0,0,520,560);

  HByteImage MreutAll("mreut4_3");
  MreutAll.Display(w);

  HByteImage MreutGauss = MreutAll.GaussImage(9);
  HRegion Bright = (MreutAll >= 160) & (MreutAll >= MreutGauss+8);
  HRegion Skeleton = (((Bright.Connection()).
                     SelectShape("area","and",50,100000)).
                     Union1()).Skeleton();
  HXLDContArray LocalMax = ((Skeleton.GenContoursSkeletonXld(1,"filter")).
                           SmoothContoursXld(5)).LocalMaxContoursXld(MreutAll,70,15,4);

  long num = LocalMax.Num();
  cout << num << " Lines found." << endl;

  cout << "output as XLD-contours" << endl;
  w.SetColor("red");
  LocalMax.Display(w);

  (void)w.Click();

  cout << "Output as C++-contours" << endl;
  w.SetColor("green");
  HContourArray2D Contours(LocalMax);
  Contours.Display(w);

  cout << "Increased output: display rectangle " << endl;
  HRectangle1 rect = w.DrawRectangle1();
  w.SetPart(rect.UpperLeft().Y(),rect.UpperLeft().X(),
            rect.LowerRight().Y(),rect.LowerRight().X());

  cout << "Output as XLD-contours" << endl;
  w.SetColor("red");
  MreutAll.Display(w);
  LocalMax.Display(w);

  (void)w.Click();

  cout << "Output as C++-contours" << endl;
  w.SetColor("green");
  Contours.Display(w);

  (void)w.Click();

  cout << "Approximate lines with polygons (max. error: 1)" << endl;
  HXLDPolyArray LocalMaxPoly = LocalMax.GenPolygonsXld("ramer",1);

  num = LocalMaxPoly.Num();

  cout << "Output as XLD-polygons" << endl;
  w.SetPart(0,0,559,519);
  w.SetColor("red");
  MreutAll.Display(w);
  LocalMaxPoly.Display(w);

  (void)w.Click();

  cout << "Output as C++-polygons" << endl;
  w.SetColor("green");
  HPolygonArray2D Polygons(LocalMaxPoly);
  Polygons.Display(w);

  cout << "Increased output: display rectangle" << endl;
  rect = w.DrawRectangle1();
  w.SetPart(rect.UpperLeft().Y(),rect.UpperLeft().X(),
            rect.LowerRight().Y(),rect.LowerRight().X());

  cout << "Output as XLD-polygons" << endl;
  w.SetColor("red");
  MreutAll.Display(w);
  LocalMaxPoly.Display(w);

  (void)w.Click();

  cout << "Output as C++-polygons" << endl;
  w.SetColor("green");
  Polygons.Display(w);

  (void)w.Click();

  return(0);
}
