/*****************************************************************************
 * example3.cpp
 ***************************************************************************** 
 *
 * Projekt:     Halcon/C++
 * Author:      W. Eckstein
 * Description: Example for Halcon/C++
 *
 * (c) 1996-98 by MVTec Software GmbH
 *                Orleansstr. 34, D-81667 Muenchen, Germany
 *****************************************************************************
 *  Simple test program
 *     Use of pixel interators for byte-images
 *****************************************************************************
 *
 * $Revision: 1.2 $
 * $Date: 1998/02/24 10:44:06 $
 */


#include "HalconCpp.h"
 

void Add(int val)
{
  HByteImage in("mreut");
  HWindow w;
  in.Display(w);
  HByteImage out = in;
  HCircle circle(HDPoint2D(256,256),200);

  for (HImageIterator it(in,HRegion(circle)); it.Continue(); ++it)
    out[it] = HClipByte(in[it] + val);
  out.Display(w);
  (void)w.Click();
  in.Display(w);
  (void)w.Click();
}



void Move(int x, int y)
{
  HByteImage in("mreut");
  HWindow w;
  in.Display(w);
  HByteImage out = in;

  for (HImageIterator it(in,-x,-y,x,y); it.Continue(); ++it)
    out[it] = in[it(x,y)];
  out.Display(w);
  (void)w.Click();
  in.Display(w);
  (void)w.Click();
}



void SobelY()
{
  HByteImage in("mreut");
  HWindow w;
  in.Display(w);
  HByteImage out = in;

  for (HImageIterator it(in,3,3); it.Continue(); ++it)
  {
    int val = -2 * (int)in[it(-1,-1)] - 
	           (int)in[it(0,-1)] -
	       2 * (int)in[it(1,-1)] +
	       2 * (int)in[it(-1,1)] +
	           (int)in[it(0,1)] +
	       2 * (int)in[it(1,1)];
    out[it] = HClipByte(HAbs((long)val));
  }
  out.Display(w);
  (void)w.Click();
  in.Display(w);
  (void)w.Click();
}


main()
{
  Move(50,50);
  Add(50);
  SobelY();
  return(0);
}

