/*****************************************************************************
 * example5.cpp
 ***************************************************************************** 
 *
 * Projekt:     Halcon/C++
 * Author:      W. Eckstein
 * Description: Example for Halcon/C++
 *
 * (c) 1996-98 by MVTec Software GmbH
 *                Orleansstr. 34, D-81667 Muenchen, Germany
 *****************************************************************************
 *  Distribution for the size of cells 
 *****************************************************************************
 *
 * $Revision: 1.2 $
 * $Date: 1998/02/24 10:44:06 $
 */



#include "HalconCpp.h"
#include <fstream.h>
#include <iostream.h>
 

enum { MAX_WIDTH = 1300, ADD = 10 };

main()
{
  HByteImage image("woodcell");
  HWindow w;
  image.Display(w);
  HByteImage gauss   = image.GaussImage(9);
  HByteImage invert  = gauss.InvertImage();
  HRegion sheds;
  cout << "Starting Watersheds; please wait ..."; cout.flush();
  HRegionArray cells = invert.Watersheds(&sheds);
  cout << "Watersheds is ready\n"; cout.flush();
  w.SetColored(12);
  w.SetDraw("margin");
  cells.Display(w);
  // (void)w.Click();
  int  histo[MAX_WIDTH+2*ADD];
  int  i;
  for (i=0; i<MAX_WIDTH+2*ADD; i++)
    histo[i] = 0;
  for (i=0; i<cells.Num(); i++)
  {
    for (int k=-ADD; k<=ADD; k++)
      histo[(int)(cells[i].X())+k+ADD]++;
  }
  
  ofstream out("cells.dat");
  for (i=0; i<MAX_WIDTH+2*ADD; i++)
    out << i-ADD << " " << histo[i] << "\n";
  cout << "Distribution of cells saved in file 'cells.dat'";
  w.Click();
  return(0);
}


