/*****************************************************************************
 * example6.cpp
 ***************************************************************************** 
 *
 * Projekt:     Halcon/C++
 * Author:      W. Eckstein
 * Description: Example for Halcon/C++
 *
 * (c) 1996-98 by MVTec Software GmbH
 *                Orleansstr. 34, D-81667 Muenchen, Germany
 *****************************************************************************
 * Simple test program
 *    - initialize system
 *    - read image 
 *    - open graphic window 
 *    - display image 
 *    - end program with mouse click
 *****************************************************************************
 *
 * $Revision: 1.3 $
 * $Date: 1998/02/24 10:44:06 $
 */




#include "HalconCpp.h"
#include <iostream.h>
 

main()
{
  HTuple     Button;

  cout << "Read image <monkey.tif>" << endl;
  HImage    Mandrill("monkey");

  cout << "Open graphics window" << endl;
  HWindow   w;

  cout << "Display image" << endl;
  Mandrill.Display(w);

  w.SetPart (  0,100,312,412);      Mandrill.Display (w);
  w.SetPart ( 50,150,262,362);      Mandrill.Display (w);
  w.SetPart (100,200,212,312);      Mandrill.Display (w);
  w.SetPart (150,250,162,262);      Mandrill.Display (w);
  w.SetPart (155,255,157,257);      Mandrill.Display (w);
  w.SetPart (  0,  0,511,511);      Mandrill.Display (w);

  cout << "End: click with mouse button in window" << endl;
  (void)w.GetMbutton(_,&Button);

  switch (Button[0].I()) {
    case 1: 
      cout << "left button pressed\n";
      break;
    case 2: 
      cout << "middle button pressed\n";
      break;
    case 4: 
      cout << "right button pressed\n";
      break;
    default:
      cout << "multiple buttons pressed\n";
      break;
  }
  return(0);
}


