/*****************************************************************************
 * example7.cpp
 ***************************************************************************** 
 *
 * Projekt:     Halcon/C++
 * Author:      W. Eckstein
 * Description: Example for Halcon/C++
 *
 * (c) 1996-98 by MVTec Software GmbH
 *                Orleansstr. 34, D-81667 Muenchen, Germany
 *****************************************************************************
 *  Test program for generic pixel access
 *    Procedure: Pixel (access for pixel with HPixVal)
 *                 - read image   
 *                 - copy image
 *                 - invert new image 2x 
 *  Attention: SetPixVal and GetPixVal are slow!
 *             For fast pixel access see example2.cpp
 *****************************************************************************
 *
 * $Revision: 1.2 $
 * $Date: 1998/02/24 10:44:06 $
 */

#include "HalconCpp.h"
#include <iostream.h>
 

void Pixel()
{
  double t1,t2;

  HImage    in("mreut");
  HWindow   w;

  in.Display(w);

  HImage out = in;

  int  width  = out.Width();
  int  height = out.Height();

  long end    = width * height;

  (void)::count_seconds(&t1);

  for (long k = 0; k < end; k++)
  {
    int pix = in.GetPixVal(k);
    out.SetPixVal(k,255-pix);
  }

  (void)::count_seconds(&t2);

  cout << "(linear) time = " << t2-t1 << " sec" << endl;

  cout << "Transformed !" << endl;  out.Display(w);   w.Click();
  cout << "Original !"    << endl;  in.Display(w);    w.Click();

  (void)::count_seconds(&t1);

  for (int y=0; y<height; y++)
  {
    for (int x=0; x<width; x++)
    {
      int pix = in.GetPixVal(x,y);
      out.SetPixVal(x,y,255-pix);
    }
  }

  (void)::count_seconds(&t2);

  cout << "(x,y) time = " << t2-t1 << " sec" << endl;
  cout << "back transformed" << endl;

  out.Display(w);
  w.Click();
}



main()
{
  Pixel();
  return(0);
}


