/*****************************************************************************
 * example9.cpp
 ***************************************************************************** 
 *
 * Projekt:     Halcon/C++
 * Author:      W. Eckstein
 * Description: Example for Halcon/C++
 *
 * (c) 1996-98 by MVTec Software GmbH
 *                Orleansstr. 34, D-81667 Muenchen, Germany
 *****************************************************************************
 * Using XLD structures
 *****************************************************************************
 *
 * $Revision: 1.3 $
 * $Date: 1998/02/24 12:32:39 $
 */


#include "HalconCpp.h"
#include <iostream.h>
 

main()
{
  HWindow w2(0,0,520,560);

  HByteImage MreutAll("mreut4_3");
  HByteImage MreutGauss = MreutAll.GaussImage(9);
  HRegion Bright = (MreutAll >= 160) & (MreutAll >= MreutGauss+8);
  HRegion Skeleton = (((Bright.Connection()).
                     SelectShape("area","and",50,100000)).
                     Union1()).Skeleton();
  HXLDContArray LocalMax = ((Skeleton.GenContoursSkeletonXld(1,"filter")).
                           SmoothContoursXld(5)).LocalMaxContoursXld(MreutAll,70,15,4);
  HXLDPolyArray RoadCenters = (LocalMax.ClipContoursXld(1500,1542,512,512)).
                              GenPolygonsXld("ramer",2);

  cout << "Lines" << endl;
  w2.SetColor("red");
  MreutAll.Display(w2);
  LocalMax.Display(w2);

  (void)w2.Click();


  HWindow w1(0,542,512,512);
  w1.SetDraw("margin");
  w1.SetColor("red");
  w1.SetPart(0,0,511,511);

  HByteImage Mreut("mreut");
  Mreut.Display(w1);

  HByteImage EdgesAmp, EdgesDir;
  EdgesAmp = Mreut.EdgesImage(&EdgesDir,"mderiche2",0.3,"nms",20,40);

  HRegion Edges = ((EdgesAmp >= 1).Skeleton()).
                  ClipRegion(2,2,EdgesAmp.Width()-3,EdgesAmp.Height()-3);
  
  HXLDPolyArray Polygons = (Edges.GenContoursSkeletonXld(1,"filter")).
                           GenPolygonsXld("ramer",2);

  cout << "Polygons" << endl;
  Mreut.Display(w1);
  Polygons.Display(w1);
  w1.SetPart(50,50,100,100);
  (void)w1.Click();
  Mreut.Display(w1);
  Polygons.Display(w1);
  w1.SetPart(0,0,Mreut.Height()-1,Mreut.Width()-1);

  (void)w1.Click();

  HXLDParaArray Parallels = Polygons.GenParallelsXld(10,30,0.15,"true");

  cout << "Parallel polygons" << endl;
  Mreut.Display(w1);
  Parallels.Display(w1);

  (void)w1.Click();

  HXLDModParaArray ModParallels;
  HXLDExtParaArray ExtParallels;
  ModParallels = Parallels.ModParallelsXld(Mreut,&ExtParallels,0.4,160,220,10);

  cout << "Modified parallel polygons" << endl;
  Mreut.Display(w1);
  ModParallels.Display(w1);

  (void)w1.Click();

  cout << "Extended parallel polygons" << endl;
  Mreut.Display(w1);
  ExtParallels.Display(w1);

  (void)w1.Click();

  HXLDPolyArray RoadSides = Polygons.CombineRoadsXld(ModParallels,ExtParallels,
                                        RoadCenters,30*PI/180,15*PI/180,40,40);

  cout << "Road borders" << endl;
  Mreut.Display(w1);
  RoadSides.Display(w1);

  (void)w1.Click();

  return(0);
}


